/* $Id$
 *
 * hglobals.h
 */

/**************************************************************************
 *     Copyright (C) 1990 by Mark B. Phillips and Robert R. Miner	  *
 * 									  *
 * Permission to use, copy, modify, and distribute this software, its	  *
 * documentation, and any images it generates for any purpose and without *
 * fee is hereby granted, provided that					  *
 * 									  *
 * (1) the above copyright notice appear in all copies and that both that *
 *     copyright notice and this permission notice appear in supporting	  *
 *     documentation, and that the names of Mark B.  Phillips, Robert R.  *
 *     Miner, or the University of Maryland not be used in advertising or *
 *     publicity pertaining to distribution of the software without	  *
 *     specific, written prior permission.				  *
 *									  *
 * (2) Explicit written credit be given to the authors Mark B.  Phillips  *
 *     and Robert R. Miner in any publication which uses part or all of	  *
 *     any image produced by this software.				  *
 *									  *
 * This software is provided "as is" without express or implied warranty. *
 **************************************************************************/

#include <stdio.h>
#include GDB_HEADER

#define UNKNOWN			0
#define	SET_MODEL		1
#define	SET_COORD_SYS		2
#define	DRAW_POINT		3
#define	DRAW_SEGMENT		4
#define	ERASE_OBJECT		5
#define CLEAR_ALL		6
#define	BEGIN_BATCH		7
#define	END_BATCH		8
#define	GET_POINT		9
#define	GET_OBJECT		10
#define	POSTSCRIPT		11
#define	READ_FILE		12
#define QUIT_PROGRAM		13

#define INBUF_SIZE 256		/* size of input buffer */
#define MAXARGS 10		/* max # command arguments */


extern int model;
extern hWindow hwindow;
extern double vpx,vpy,vps;

extern int log_mode;
extern FILE *logf;

#define POINT		GDB_ENTITY_TYPE_1
#define SEGMENT		GDB_ENTITY_TYPE_2

#define NAMELEN		10

extern char *AddEntity();

extern int Batching, BatchDeletion;

extern gdb_Entity LastDrawn;
